Index: branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp
===================================================================
--- branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 824)
+++ branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 827)
@@ -5195,15 +5174,18 @@
 
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_CHECK> CC_TYPE_CLACK Switch slot to EMPTY state"
-              << " set = " << r_dcache_clack_set.read()
-              << " / way = " << r_dcache_clack_way.read() << std::endl;
-}
-#endif
-            break;
-        }
-
+            if (m_debug_activated)
+            {
+                std::cout << "  <PROC " << name()
+                    << " DCACHE_CC_CHECK> CLACK for PADDR " << std::hex << paddr
+                    << " Switch slot to EMPTY state : "
+                    << " set = " << std::dec << r_dcache_clack_set.read()
+                    << " / way = " << r_dcache_clack_way.read() << std::endl;
+            }
+#endif
+            break;
+        }
+
+        assert(not r_dcache_cc_send_req.read() and
+        "CC_SEND must be available in DCACHE_CC_CHECK");
 
         // Match between MISS address and CC address
@@ -5211,6 +5193,6 @@
         // because the CLACK access the directory but the MISS match dont.
         if (r_cc_receive_dcache_req.read() and
-          ((r_dcache_fsm_cc_save == DCACHE_MISS_SELECT  )  or
-           (r_dcache_fsm_cc_save == DCACHE_MISS_WAIT    )  or
+          ((r_dcache_fsm_cc_save == DCACHE_MISS_SELECT)  or
+           (r_dcache_fsm_cc_save == DCACHE_MISS_WAIT)  or
            (r_dcache_fsm_cc_save == DCACHE_MISS_DIR_UPDT)) and
           ((r_dcache_vci_paddr.read() & mask) == (paddr & mask))) // matching
@@ -5223,6 +5205,6 @@
             if (r_cc_receive_dcache_type.read() == CC_TYPE_UPDT)
             {
-                r_dcache_fsm        = DCACHE_CC_UPDT;
-                r_dcache_cc_word    = r_cc_receive_word_idx.read();
+                r_dcache_fsm     = DCACHE_CC_UPDT;
+                r_dcache_cc_word = r_cc_receive_word_idx.read();
 
                 // just pop the fifo , don't write in icache
@@ -5237,15 +5219,12 @@
 
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_CHECK> Coherence request matching a pending miss:"
-              << " PADDR = " << std::hex << paddr << std::endl;
-}
-#endif
-        }
-
-
-        assert ( not r_dcache_cc_send_req.read() and "CC_SEND must be available in DCACHE_CC_CHECK" );
+            if (m_debug_activated)
+            {
+                std::cout << "  <PROC " << name()
+                    << " DCACHE_CC_CHECK> Coherence request matching a pending miss:"
+                    << " PADDR = " << std::hex << paddr << std::endl;
+            }
+#endif
+        }
 
         // CC request handler
@@ -5257,11 +5236,11 @@
 
 #ifdef INSTRUMENTATION
-m_cpt_dcache_dir_read++;
-#endif
-        r_dcache.read_dir( paddr,
-                           &state,
-                           &way,
-                           &set,
-                           &word ); // unused
+        m_cpt_dcache_dir_read++;
+#endif
+        r_dcache.read_dir(paddr,
+                          &state,
+                          &way,
+                          &set,
+                          &word); // unused
 
         r_dcache_cc_state = state;
@@ -5269,5 +5248,6 @@
         r_dcache_cc_set = set;
 
-        if ((state == CACHE_SLOT_STATE_VALID_CC) or (state == CACHE_SLOT_STATE_VALID_NCC))  // hit
+        if ((state == CACHE_SLOT_STATE_VALID_CC) or
+            (state == CACHE_SLOT_STATE_VALID_NCC))  // hit
         {
             // need to update the cache state
@@ -5276,6 +5256,6 @@
             if (r_cc_receive_dcache_type.read() == CC_TYPE_UPDT)  // hit update
             {
-                r_dcache_fsm          = DCACHE_CC_UPDT;
-                r_dcache_cc_word      = r_cc_receive_word_idx.read();
+                r_dcache_fsm     = DCACHE_CC_UPDT;
+                r_dcache_cc_word = r_cc_receive_word_idx.read();
             }
             else if (r_cc_receive_dcache_type.read() == CC_TYPE_INVAL)   // hit inval
@@ -5283,9 +5263,9 @@
                 if (state == CACHE_SLOT_STATE_VALID_NCC)
                 {
-                    r_dcache_cc_inval_addr = (paddr &~0x3F);
+                    r_dcache_cc_inval_addr = (paddr & ~0x3F);
                     r_dcache_cc_inval_data_cpt = 0;
                 }
-                r_dcache_fsm          = DCACHE_CC_INVAL;
-                r_dcache_dirty_save   = false;
+                r_dcache_fsm        = DCACHE_CC_INVAL;
+                r_dcache_dirty_save = false;
             }
         }
@@ -5293,8 +5273,8 @@
         {
             // multicast acknowledgement required in case of update
-            if(r_cc_receive_dcache_type.read() == CC_TYPE_UPDT)
-            {
-                r_dcache_fsm           = DCACHE_CC_UPDT;
-                r_dcache_cc_word       = r_cc_receive_word_idx.read();
+            if (r_cc_receive_dcache_type.read() == CC_TYPE_UPDT)
+            {
+                r_dcache_fsm     = DCACHE_CC_UPDT;
+                r_dcache_cc_word = r_cc_receive_word_idx.read();
 
                 // just pop the fifo , don't write in icache
@@ -5309,17 +5289,16 @@
 
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_CHECK> Coherence request received:"
-              << " PADDR = " << std::hex << paddr
-              << " / TYPE = " << std::dec << r_cc_receive_dcache_type.read()
-              << " / HIT = " << ((state == CACHE_SLOT_STATE_VALID_CC) or (state == CACHE_SLOT_STATE_VALID_NCC)) << std::endl;
-}
+        if (m_debug_activated)
+        {
+            std::cout << "  <PROC " << name()
+                << " DCACHE_CC_CHECK> Coherence request received:"
+                << " PADDR = " << std::hex << paddr
+                << " / TYPE = " << std::dec << r_cc_receive_dcache_type.read()
+                << " / HIT = " << ((state == CACHE_SLOT_STATE_VALID_CC) or (state == CACHE_SLOT_STATE_VALID_NCC)) << std::endl;
+        }
 #endif
 
         break;
     }
-
     /////////////////////
     case DCACHE_CC_INVAL: // hit inval: switch slot to ZOMBI state and send a
@@ -5327,37 +5306,37 @@
                           // TLBs
     {
-        size_t way    = r_dcache_cc_way.read();
-        size_t set    = r_dcache_cc_set.read();
-        int      cache_state = r_dcache_cc_state.read();
-        bool     dirty_save = false;
+        size_t way = r_dcache_cc_way.read();
+        size_t set = r_dcache_cc_set.read();
+        int  cache_state = r_dcache_cc_state.read();
+        bool dirty_save = false;
 
         if (r_dcache_cc_need_write.read())
         {
-            if ( r_dcache_content_state[way*m_dcache_sets+set] == LINE_CACHE_IN_TLB )
-            {
-                r_dcache_content_state[way*m_dcache_sets+set] = LINE_CACHE_DATA_NOT_DIRTY;//need to remember it was dirty for cleanup
+            if (r_dcache_content_state[way * m_dcache_sets + set] == LINE_CACHE_IN_TLB)
+            {
+                r_dcache_content_state[way * m_dcache_sets + set] = LINE_CACHE_DATA_NOT_DIRTY; //need to remember it was dirty for cleanup
                 dirty_save = true;
                 r_dcache_dirty_save = true;
-                r_dcache_tlb_inval_line  = r_cc_receive_dcache_nline.read();
-                r_dcache_tlb_inval_set   = 0;
-                r_dcache_fsm_scan_save   = r_dcache_fsm.read();
-                r_dcache_fsm             = DCACHE_INVAL_TLB_SCAN;
+                r_dcache_tlb_inval_line = r_cc_receive_dcache_nline.read();
+                r_dcache_tlb_inval_set  = 0;
+                r_dcache_fsm_scan_save  = r_dcache_fsm.read();
+                r_dcache_fsm = DCACHE_INVAL_TLB_SCAN;
                 break;
             }
             else
             {
-                if ( r_dcache_content_state[way*m_dcache_sets+set] == LINE_CACHE_CONTAINS_PTD )
+                if (r_dcache_content_state[way * m_dcache_sets + set] == LINE_CACHE_CONTAINS_PTD)
                 {
                     r_itlb.reset();
                     r_dtlb.reset();
-                    r_dcache_content_state[way*m_dcache_sets+set] = LINE_CACHE_DATA_NOT_DIRTY;
+                    r_dcache_content_state[way * m_dcache_sets + set] = LINE_CACHE_DATA_NOT_DIRTY;
                     dirty_save = true;
                     r_dcache_dirty_save = true;
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_INVAL> Flush DTLB & ITLB" << std::endl;
-}
+                    if (m_debug_activated)
+                    {
+                        std::cout << "  <PROC " << name()
+                            << " DCACHE_CC_INVAL> Flush DTLB & ITLB" << std::endl;
+                    }
 #endif
                 }
@@ -5365,17 +5344,17 @@
                 // If the type of inval request from Memcache is configuration
                 // (software), we send a classic CLEANUP
-                if (cache_state == CACHE_SLOT_STATE_VALID_CC or r_cc_receive_dcache_inval_is_config.read())
-                {
-                    r_dcache.write_dir( way,
-                                        set,
-                                        CACHE_SLOT_STATE_ZOMBI );
-                }
-
+                if (cache_state == CACHE_SLOT_STATE_VALID_CC or
+                    r_cc_receive_dcache_inval_is_config.read())
+                {
+                    r_dcache.write_dir(way,
+                                       set,
+                                       CACHE_SLOT_STATE_ZOMBI);
+                }
                 r_dcache_cc_need_write = false;
             }
         }
-        assert (not r_dcache_cc_send_req.read() &&
-                    "ERROR in DCACHE_CC_INVAL: the r_dcache_cc_send_req "
-                    "must not be set");
+        assert(not r_dcache_cc_send_req.read() and
+               "ERROR in DCACHE_CC_INVAL: the r_dcache_cc_send_req "
+               "must not be set");
         // coherence request completed
         r_cc_receive_dcache_req = false;
@@ -5386,22 +5365,25 @@
         r_dcache_cc_send_type = CC_TYPE_CLEANUP;
 
-        if (cache_state == CACHE_SLOT_STATE_VALID_NCC and not r_cc_receive_dcache_inval_is_config.read())
+        if (cache_state == CACHE_SLOT_STATE_VALID_NCC and
+            not r_cc_receive_dcache_inval_is_config.read())
         {
             r_dcache_cc_cleanup_line_ncc = true;
-            if ((r_dcache_content_state[way*m_dcache_sets+set] != LINE_CACHE_DATA_NOT_DIRTY) or r_dcache_dirty_save.read() or dirty_save) //must send data
+            if ((r_dcache_content_state[way * m_dcache_sets + set] != LINE_CACHE_DATA_NOT_DIRTY) or
+                 r_dcache_dirty_save.read() or
+                 dirty_save) //must send data
             {
                 r_dcache_cc_cleanup_updt_data = true;
-                for (size_t w = 0; w< m_dcache_words; w++)
-                {
-                    m_cpt_cleanup_data_dirty_word += r_dcache_dirty_word[(m_dcache_sets*way+set)*m_dcache_words + w];
-                }
-
-                r_dcache_fsm          = DCACHE_CC_INVAL_DATA;
+                for (size_t w = 0; w < m_dcache_words; w++)
+                {
+                    m_cpt_cleanup_data_dirty_word += r_dcache_dirty_word[(m_dcache_sets * way + set) * m_dcache_words + w];
+                }
+
+                r_dcache_fsm = DCACHE_CC_INVAL_DATA;
             }
             else
             {
-                r_dcache.write_dir( way,
-                                    set,
-                                    CACHE_SLOT_STATE_ZOMBI );
+                r_dcache.write_dir(way,
+                                   set,
+                                   CACHE_SLOT_STATE_ZOMBI);
 
                 r_dcache_cc_cleanup_updt_data = false;
@@ -5417,5 +5399,4 @@
         break;
     }
-
     /////////////////////
     case DCACHE_CC_INVAL_DATA:
@@ -5423,7 +5404,7 @@
 
         uint32_t rdata;
-        size_t   way = 0; // to avoid gcc warning
-        size_t   set = 0; // to avoid gcc warning
-        size_t   word;
+        size_t way = 0; // to avoid gcc warning
+        size_t set = 0; // to avoid gcc warning
+        size_t word;
         r_dcache.read_neutral(r_dcache_cc_inval_addr.read(),
                               &rdata,
@@ -5431,19 +5412,19 @@
                               &set,
                               &word);
-        if(r_cc_send_data_fifo.wok())
+        if (r_cc_send_data_fifo.wok())
         {
             r_dcache_cc_inval_addr = r_dcache_cc_inval_addr.read() + 4;
 
-            cleanup_data_updt_fifo_dcache_put   = true;
-            cleanup_data_updt_fifo_dcache_data  = rdata;
+            cleanup_data_updt_fifo_dcache_put = true;
+            cleanup_data_updt_fifo_dcache_data = rdata;
 
             r_dcache_cc_inval_data_cpt = r_dcache_cc_inval_data_cpt.read() + 1;
-            if(r_dcache_cc_inval_data_cpt.read() == (m_dcache_words - 1))
+            if (r_dcache_cc_inval_data_cpt.read() == (m_dcache_words - 1))
             {
                 r_dcache_cc_inval_data_cpt = 0;
-                r_dcache_fsm          = r_dcache_fsm_cc_save.read();
+                r_dcache_fsm = r_dcache_fsm_cc_save.read();
                 r_dcache.write_dir(way,
                                    set,
-                                   CACHE_SLOT_STATE_ZOMBI );
+                                   CACHE_SLOT_STATE_ZOMBI);
             }
         }
@@ -5451,70 +5432,70 @@
     }
     ///////////////////
-    case DCACHE_CC_UPDT:        // hit update: write one word per cycle,
-                                // after possible invalidation of copies in TLBs
-    {
-        size_t word       = r_dcache_cc_word.read();
-        size_t way        = r_dcache_cc_way.read();
-        size_t set        = r_dcache_cc_set.read();
-
-            if (r_dcache_cc_need_write.read())
-            {
-                if ( r_dcache_content_state[way*m_dcache_sets+set] == LINE_CACHE_IN_TLB )
-                {
-                    r_dcache_content_state[way*m_dcache_sets+set] = LINE_CACHE_DATA_NOT_DIRTY;
-                    r_dcache_tlb_inval_line  = r_cc_receive_dcache_nline.read();
-                    r_dcache_tlb_inval_set   = 0;
-                    r_dcache_fsm_scan_save   = r_dcache_fsm.read();
-                    r_dcache_fsm             = DCACHE_INVAL_TLB_SCAN;
-                    break;
-                }
-                if ( r_dcache_content_state[way*m_dcache_sets+set] == LINE_CACHE_CONTAINS_PTD )
-                {
-                    r_itlb.reset();
-                    r_dtlb.reset();
-                    r_dcache_content_state[way*m_dcache_sets+set] = LINE_CACHE_DATA_NOT_DIRTY;
+    case DCACHE_CC_UPDT: // hit update: write one word per cycle,
+                         // after possible invalidation of copies in TLBs
+    {
+        size_t word = r_dcache_cc_word.read();
+        size_t way  = r_dcache_cc_way.read();
+        size_t set  = r_dcache_cc_set.read();
+
+        if (r_dcache_cc_need_write.read())
+        {
+            if (r_dcache_content_state[way * m_dcache_sets + set] == LINE_CACHE_IN_TLB)
+            {
+                r_dcache_content_state[way * m_dcache_sets + set] = LINE_CACHE_DATA_NOT_DIRTY;
+                r_dcache_tlb_inval_line = r_cc_receive_dcache_nline.read();
+                r_dcache_tlb_inval_set  = 0;
+                r_dcache_fsm_scan_save  = r_dcache_fsm.read();
+                r_dcache_fsm            = DCACHE_INVAL_TLB_SCAN;
+                break;
+            }
+            if (r_dcache_content_state[way * m_dcache_sets + set] == LINE_CACHE_CONTAINS_PTD)
+            {
+                r_itlb.reset();
+                r_dtlb.reset();
+                r_dcache_content_state[way * m_dcache_sets + set] = LINE_CACHE_DATA_NOT_DIRTY;
 
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_UPDT> Flush DTLB & ITLB" << std::endl;
-}
-#endif
-                }
-
-                assert (not r_dcache_cc_send_req.read() &&
-                        "ERROR in DCACHE_CC_INVAL: the r_dcache_cc_send_req "
-                        "must not be set");
-
-                if ( not r_cc_receive_updt_fifo_be.rok() ) break;
+                if (m_debug_activated)
+                {
+                    std::cout << "  <PROC " << name()
+                        << " DCACHE_CC_UPDT> Flush DTLB & ITLB" << std::endl;
+                }
+#endif
+            }
+
+            assert(not r_dcache_cc_send_req.read() &&
+                   "ERROR in DCACHE_CC_INVAL: the r_dcache_cc_send_req "
+                   "must not be set");
+
+            if (not r_cc_receive_updt_fifo_be.rok()) break;
 
 #ifdef INSTRUMENTATION
-m_cpt_dcache_data_write++;
-#endif
-            r_dcache.write( way,
-                            set,
-                            word,
-                            r_cc_receive_updt_fifo_data.read(),
-                            r_cc_receive_updt_fifo_be.read() );
+            m_cpt_dcache_data_write++;
+#endif
+            r_dcache.write(way,
+                           set,
+                           word,
+                           r_cc_receive_updt_fifo_data.read(),
+                           r_cc_receive_updt_fifo_be.read());
 
             r_dcache_cc_word = word + 1;
 
 #if DEBUG_DCACHE
-if ( m_debug_activated )
-{
-    std::cout << "  <PROC " << name()
-              << " DCACHE_CC_UPDT> Write one word" << std::dec
-              << " / WAY = " << way
-              << " / SET = " << set
-              << " / WORD = " << word
-              << " / VALUE = " << std::hex << r_cc_receive_updt_fifo_data.read() << std::endl;
-}
-#endif
-        }
-
-        if ( not r_cc_receive_updt_fifo_be.rok() ) break;
-
-        if ( r_cc_receive_updt_fifo_eop.read() )  // last word
+            if (m_debug_activated)
+            {
+                std::cout << "  <PROC " << name()
+                    << " DCACHE_CC_UPDT> Write one word" << std::dec
+                    << " / WAY = " << way
+                    << " / SET = " << set
+                    << " / WORD = " << word
+                    << " / VALUE = " << std::hex << r_cc_receive_updt_fifo_data.read() << std::endl;
+            }
+#endif
+        }
+
+        if (not r_cc_receive_updt_fifo_be.rok()) break;
+
+        if (r_cc_receive_updt_fifo_eop.read())  // last word
         {
             // no need to write in the cache anymore
@@ -5528,5 +5509,4 @@
             r_dcache_cc_send_updt_tab_idx = r_cc_receive_dcache_updt_tab_idx.read();
             r_dcache_cc_send_type         = CC_TYPE_MULTI_ACK;
-
             r_dcache_fsm                  = r_dcache_fsm_cc_save.read();
         }
@@ -5538,57 +5518,59 @@
     }
     ///////////////////////////
-    case DCACHE_INVAL_TLB_SCAN:         // Scan sequencially all sets for both ITLB & DTLB
-                                        // It makes assumption: m_itlb_sets == m_dtlb_sets
-                                        // All ways are handled in parallel.
-                                        // We enter this state when a DCACHE line is modified,
-                                        // and there is a copy in itlb or dtlb.
-                                        // It can be caused by:
-                                        // - a coherence inval or updt transaction,
-                                        // - a line inval caused by a cache miss
-                                        // - a processor XTN inval request,
-                                        // - a WRITE hit,
-                                        // - a Dirty bit update
-                                        // Input arguments are:
-                                        // - r_dcache_tlb_inval_line
-                                        // - r_dcache_tlb_inval_set
-                                        // - r_dcache_fsm_scan_save
+    case DCACHE_INVAL_TLB_SCAN:  // Scan sequencially all sets for both ITLB & DTLB
+                                 // It makes assumption: m_itlb_sets == m_dtlb_sets
+                                 // All ways are handled in parallel.
+                                 // We enter this state when a DCACHE line is modified,
+                                 // and there is a copy in itlb or dtlb.
+                                 // It can be caused by:
+                                 // - a coherence inval or updt transaction,
+                                 // - a line inval caused by a cache miss
+                                 // - a processor XTN inval request,
+                                 // - a WRITE hit,
+                                 // - a Dirty bit update
+                                 // Input arguments are:
+                                 // - r_dcache_tlb_inval_line
+                                 // - r_dcache_tlb_inval_set
+                                 // - r_dcache_fsm_scan_save
     {
         paddr_t line = r_dcache_tlb_inval_line.read();
-        size_t  set  = r_dcache_tlb_inval_set.read();
-        size_t  way;
-        bool    ok;
-
-        for ( way = 0 ; way < m_itlb_ways ; way++ )
-        {
-            ok = r_itlb.inval( line, way, set );
+        size_t set = r_dcache_tlb_inval_set.read();
+        size_t way;
+        bool ok;
+
+        for (way = 0; way < m_itlb_ways; way++)
+        {
+            ok = r_itlb.inval(line, way, set);
 
 #if DEBUG_DCACHE
-if ( m_debug_activated and ok )
-{
-    std::cout << "  <PROC " << name()
-              << ".DCACHE_INVAL_TLB_SCAN> Invalidate ITLB entry:" << std::hex
-              << " line = " << line << std::dec
-              << " / set = " << set
-              << " / way = " << way << std::endl;
-}
-#endif
-        }
-
-        for ( way = 0 ; way < m_dtlb_ways ; way++ )
-        {
-            ok = r_dtlb.inval( line, way, set );
+            if (m_debug_activated and ok)
+            {
+                std::cout << "  <PROC " << name()
+                    << ".DCACHE_INVAL_TLB_SCAN> Invalidate ITLB entry:" << std::hex
+                    << " line = " << line << std::dec
+                    << " / set = " << set
+                    << " / way = " << way << std::endl;
+            }
+#endif
+        }
+
+        for (way = 0; way < m_dtlb_ways; way++)
+        {
+            ok = r_dtlb.inval(line, way, set);
 
 #if DEBUG_DCACHE
-if ( m_debug_activated and ok )
-std::cout << "  <PROC " << name() << " DCACHE_INVAL_TLB_SCAN>"
-          << " Invalidate DTLB entry" << std::hex
-          << " / line = " << line << std::dec
-          << " / set = " << set
-          << " / way = " << way << std::endl;
+            if (m_debug_activated and ok)
+            {
+                std::cout << "  <PROC " << name() << " DCACHE_INVAL_TLB_SCAN>"
+                    << " Invalidate DTLB entry" << std::hex
+                    << " / line = " << line << std::dec
+                    << " / set = " << set
+                    << " / way = " << way << std::endl;
+            }
 #endif
         }
 
         // return to the calling state when TLB inval completed
-        if ( r_dcache_tlb_inval_set.read() == (m_dtlb_sets-1) )
+        if (r_dcache_tlb_inval_set.read() == (m_dtlb_sets - 1))
         {
             r_dcache_fsm = r_dcache_fsm_scan_save.read();
@@ -5609,9 +5591,9 @@
     // The simulation exit if the number of consecutive frozen cycles
     // is larger than the m_max_frozen_cycles (constructor parameter)
-    if ( (m_ireq.valid and not m_irsp.valid) or (m_dreq.valid and not m_drsp.valid) )
-    {
-        m_cpt_frz_cycles++;         // used for instrumentation
-        m_cpt_stop_simulation++;    // used for debug
-        if ( m_cpt_stop_simulation > m_max_frozen_cycles )
+    if ((m_ireq.valid and not m_irsp.valid) or (m_dreq.valid and not m_drsp.valid))
+    {
+        m_cpt_frz_cycles++;      // used for instrumentation
+        m_cpt_stop_simulation++; // used for debug
+        if (m_cpt_stop_simulation > m_max_frozen_cycles)
         {
             std::cout << std::dec << "ERROR in CC_VCACHE_WRAPPER " << name() << std::endl
@@ -5630,7 +5612,7 @@
     /////////// execute one iss cycle /////////////////////////////////
     {
-    uint32_t it = 0;
-    for (size_t i=0; i<(size_t)iss_t::n_irq; i++) if(p_irq[i].read()) it |= (1<<i);
-    r_iss.executeNCycles(1, m_irsp, m_drsp, it);
+        uint32_t it = 0;
+        for (size_t i = 0; i < (size_t) iss_t::n_irq; i++) if (p_irq[i].read()) it |= (1 << i);
+        r_iss.executeNCycles(1, m_irsp, m_drsp, it);
     }
 
@@ -5676,5 +5658,5 @@
 
 
-    switch ( r_vci_cmd_fsm.read() )
+    switch (r_vci_cmd_fsm.read())
     {
         //////////////
